//
//  MyTests.m
//  TestGame
//
//  Created by Mitchell Allen on 9/20/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//
// See these links for additional info and credit:
// http://mitchallen.com/iphone/archives/371
// http://mitchallen.com/iphone/archives/304
// http://mitchallen.com/iphone/archives/424
// 

#import "MyTests.h"

#pragma mark -

@implementation TestLayer01

-(void) onEnter
{
	// Code borrowed from cocos2d sample: 
	// SpritesTest.m - SpriteMove class
	
	[super onEnter];
	
	CGSize s = [[Director sharedDirector] winSize];
	
	id actionTo = [MoveTo actionWithDuration: 2 position:ccp(s.width-40, s.height-40)];
	
	id actionBy = [MoveBy actionWithDuration:2  position: ccp(80,80)];
	id actionByBack = [actionBy reverse];
	
	[tamara runAction: actionTo];
	[grossini runAction: [Sequence actions:actionBy, actionByBack, nil]];
	
}

-(NSString *) title
{
	// Override the base classes title 
	// that appears on the screen.
	
	return @"Test Layer 01 - Move";
}
@end

#pragma mark -

@implementation TestLayer02

-(void) onEnter
{
	// Code borrowed from cocos2d sample: 
	// SpritesTest.m - SpriteRotate class
	
	[super onEnter];
	
	[self centerSprites];
	
	id actionTo = [RotateTo actionWithDuration: 2 angle:45];
	id actionBy = [RotateBy actionWithDuration:2  angle: 360];
	id actionByBack = [actionBy reverse];
	
	[tamara runAction: actionTo];
	[grossini runAction: 
		[Sequence actions:actionBy, actionByBack, nil]];
}

-(NSString *) title
{
	// Override the base classes title 
	// that appears on the screen.
	
	return @"Test Layer 02 - Rotate";
}
@end

#pragma mark -

@implementation TestLayer03

#define LAYER_03_BOXES	4

-(id) init {
	
	self = [super init];
	
	if(self != nil) {
		
		//////////////////////////////
		// Add Boxes
		
		for( int i = 0; i < LAYER_03_BOXES; i++ ) {
			
			// Copy blocks.png from Cocos2D resources.
			
			box[i] = 
			  [[mcaBoxSprite spriteWithFile:@"blocks.png"] retain];
			
			box[i].onTouchBegan = @selector(touchBox:);
			
			[mcaBoxSprite track:box[i]];
			
			float bx = 50;
			float by = 50 * (1 + i);
			
			box[i].position = cpv( bx, by );
			
			box[i].scaleY = 0.5f;
			box[i].scaleX = 0.5f;
			
			box[i].rotation = 0.0f;
			
			[self addChild: box[i]];
		}
		
		//////////////////////////
		// Enable interaction.
		
		isTouchEnabled = YES;	// To enable touching
	}
	
	return self;
}

-(void) onEnter
{	
	[super onEnter];
}

-(void) onExit
{		
	[super onExit];
	
	for( int i = 0; i < LAYER_03_BOXES; i++ ) {
		
		[mcaBoxSprite untrack:box[i]];
	}
	
}

-(void) touchBox: (id) theBox {
		
	[theBox turn: 10];
	
}

- (BOOL)ccTouchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
	
    UITouch *touch = [touches anyObject];
	
	CGPoint location = [[Director sharedDirector] 
						convertCoordinate: 
						[touch locationInView:touch.view]];
	
    NSArray * mySprites = [mcaTouchSprite allMySprites];
    NSUInteger i, count = [mySprites count];
	
	// NSLog( @"COUNT = %d", count );
	
    for (i = 0; i < count; i++) {
		
        mcaTouchSprite * obj 
			= (mcaTouchSprite *)[mySprites objectAtIndex:i];
		
        if (CGRectContainsPoint([obj rect], location) ) {
			
            // code here is only executed if obj has been touched
			// NSLog( @"Sprite touched." );
			
			if( [self respondsToSelector: obj.onTouchBegan ] ) {
				
				[self 
					performSelector: obj.onTouchBegan 
					withObject: obj];
			}
			
			return kEventHandled;
        }
    }
	
	return false;
}

- (BOOL)ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
	
	return false;
}

-(void) dealloc
{
	for( int i = 0; i < LAYER_03_BOXES; i++ ) {
		
		[box[i] release];
	}
	
	[super dealloc];
}

-(NSString *) title
{
	// Override the base classes title 
	// that appears on the screen.
	
	return @"Test Layer 03 - Touch";
}
@end


